"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const style_1 = __importDefault(require("./style"));
const IconButton_1 = __importDefault(require("../IconButton"));
const Mask_1 = __importDefault(require("../Mask"));
const reducer_1 = __importDefault(require("../Fn/reducer"));
const $$ = react_native_1.Dimensions.get('window');
;
const Drawer = ({ cRef, position = 'bottom', height, width, maxHeight = 500, maxWidth = 400, title, header, footer, children, duration = 600, scrollView = true, styleContainer = {}, styleScroll = {}, styleFooter = {}, styleHeader = {}, onClose, }) => {
    const moveBAnim = (0, react_1.useRef)(new react_native_1.Animated.Value($$.height)).current;
    const moveTAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(-$$.height)).current;
    const moveLAnim = (0, react_1.useRef)(new react_native_1.Animated.Value(-$$.width)).current;
    const moveRAnim = (0, react_1.useRef)(new react_native_1.Animated.Value($$.width)).current;
    const useMask = (0, react_1.useRef)();
    const initState = {
        show: false,
        styleAnimate: {},
    };
    const [state, dispatch] = (0, reducer_1.default)(Object.assign({}, initState));
    (0, react_1.useImperativeHandle)(cRef, () => ({
        show: () => {
            _onShow();
        },
        hide: () => {
            _onClose();
        }
    }));
    const _onShow = () => {
        const opts = {
            show: true
        };
        switch (position) {
            case 'bottom':
                opts.styleAnimate = {
                    left: 0,
                    bottom: 0,
                    width: $$.width,
                    transform: [{ translateY: moveBAnim }],
                };
                if (height) {
                    opts.styleAnimate.height = height;
                }
                else {
                    if (maxHeight !== 'auto') {
                        opts.styleAnimate.maxHeight = maxHeight;
                    }
                }
                break;
            case 'top':
                opts.styleAnimate = {
                    left: 0,
                    top: 0,
                    width: $$.width,
                    transform: [{ translateY: moveTAnim }],
                };
                if (height) {
                    opts.styleAnimate.height = height;
                }
                else {
                    if (maxHeight !== 'auto') {
                        opts.styleAnimate.maxHeight = maxHeight;
                    }
                }
                break;
            case 'left':
                opts.styleAnimate = {
                    left: 0,
                    top: 0,
                    height: $$.height,
                    transform: [{ translateX: moveLAnim }],
                };
                if (width) {
                    opts.styleAnimate.width = width;
                }
                else {
                    if (maxWidth !== 'auto') {
                        opts.styleAnimate.maxWidth = maxWidth;
                    }
                }
                break;
            case 'right':
                opts.styleAnimate = {
                    right: 0,
                    top: 0,
                    height: $$.height,
                    transform: [{ translateX: moveRAnim }],
                };
                if (width) {
                    opts.styleAnimate.width = width;
                }
                else {
                    if (maxWidth !== 'auto') {
                        opts.styleAnimate.maxWidth = maxWidth;
                    }
                }
                break;
        }
        dispatch(Object.assign({}, opts));
    };
    (0, react_1.useEffect)(() => {
        var _a, _b;
        if (!state.show)
            return;
        (_b = (_a = useMask === null || useMask === void 0 ? void 0 : useMask.current) === null || _a === void 0 ? void 0 : _a.show) === null || _b === void 0 ? void 0 : _b.call(_a);
        fadeIn();
    }, [state.show]);
    const _onClose = () => {
        var _a;
        (_a = useMask === null || useMask === void 0 ? void 0 : useMask.current) === null || _a === void 0 ? void 0 : _a.hide();
        fadeOut();
        setTimeout(() => {
            dispatch(Object.assign({}, initState));
            onClose === null || onClose === void 0 ? void 0 : onClose();
        }, duration - 1);
    };
    const fadeOut = () => {
        let move = null;
        let value = 0;
        switch (position) {
            case 'top':
                move = moveTAnim;
                value = -$$.height;
                break;
            case 'bottom':
                move = moveBAnim;
                value = $$.height;
                break;
            case 'left':
                move = moveLAnim;
                value = -$$.width;
                break;
            case 'right':
                move = moveRAnim;
                value = $$.width;
                break;
        }
        react_native_1.Animated.timing(move, {
            toValue: value,
            duration,
            useNativeDriver: true
        }).start();
    };
    const fadeIn = () => {
        let move = null;
        switch (position) {
            case 'top':
                move = moveTAnim;
                break;
            case 'bottom':
                move = moveBAnim;
                break;
            case 'left':
                move = moveLAnim;
                break;
            case 'right':
                move = moveRAnim;
                break;
        }
        react_native_1.Animated.timing(move, {
            toValue: 0,
            duration,
            useNativeDriver: true
        }).start();
    };
    const headerDefault = () => {
        return (react_1.default.createElement(react_native_1.View, { style: style_1.default.title },
            react_1.default.createElement(react_native_1.View, { style: style_1.default.left }),
            react_1.default.createElement(react_native_1.Text, { style: [style_1.default.mid, title ? { lineHeight: 50 } : {}] }, title),
            react_1.default.createElement(IconButton_1.default, { styleContainer: style_1.default.right, name: 'close', size: 20, onPress: () => {
                    _onClose();
                } })));
    };
    const renderHeader = () => {
        if (header === false)
            return null;
        if (header)
            return header;
        if (['top', 'left', 'right'].includes(position)) {
            return (react_1.default.createElement(react_native_1.SafeAreaView, { style: styleHeader }, headerDefault()));
        }
        return headerDefault();
    };
    const renderFooter = () => {
        if (!footer)
            return null;
        if (['bottom', 'left', 'right'].includes(position)) {
            return (react_1.default.createElement(react_native_1.SafeAreaView, { style: styleFooter }, footer));
        }
        return footer;
    };
    const renderContent = () => {
        if (!scrollView)
            return react_1.default.createElement(react_1.default.Fragment, null, children);
        return (react_1.default.createElement(react_native_1.ScrollView, { style: [style_1.default.scroll, Object.assign({}, styleScroll)] }, children));
    };
    const renderView = () => {
        if (!state.show)
            return null;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Mask_1.default, { cRef: useMask, duration: duration }),
            react_1.default.createElement(react_native_1.Animated.View, { style: [
                    style_1.default.container,
                    Object.assign({}, styleContainer),
                    Object.assign({}, state.styleAnimate)
                ] },
                renderHeader(),
                renderContent(),
                renderFooter())));
    };
    return renderView();
};
exports.default = Drawer;
